//
//
//	Binary file parser class
//
//											(C) 1997 JoOl


#ifndef _BIN_PARSER
#define _BIN_PARSER

#include "Parser.h"
#include "LexerBin.h"



class					ParserBin : public Parser
{

#define PRINT0(s)							_PRINT1("%s"s, Indent)
#define PRINT1(s, a)						_PRINT2("%s"s, Indent, a)
#define PRINT2(s, a, b)						_PRINT3("%s"s, Indent, a, b)
#define PRINT3(s, a, b, c)					_PRINT4("%s"s, Indent, a, b, c)
#define PRINT4(s, a, b, c, d)				_PRINT5("%s"s, Indent, a, b, c, d)
#define PRINT5(s, a, b, c, d, e)			_PRINT6("%s"s, Indent, a, b, c, d, e)
#define PRINT6(s, a, b, c, d, e, f)		_PRINT7("%s"s, Indent, a, b, c, d, e, f)
#define PRINT7(s, a, b, c, d, e, f, g)		_PRINT8("%s"s, Indent, a, b, c, d, e, f, g)


protected:

	LexerBin*			Lexr;

public:

#pragma export on

	ParserBin(bool V);
	~ParserBin();

	char*				DetachLexeme(char* );
	void				DeleteLexeme(char* );

	virtual bool		SetInput(entry_ref& , tEndian );
	virtual void		Terminate();

	bool				EndOfFile();
	Symbol*				SearchSymbol(char* );
	void				PrintSymbol(Symbol* );

	bool				ReadInt8(uint8& );
	bool				ReadInt16(uint16& );
	bool				ReadInt32(uint32& );
	bool				ReadFloat(float& );
	bool				ReadDouble(double& );
	bool				ReadBytes(uint32 , char* );
	bool				ReadString(uint32 , char* );
	bool				SkipBytes(uint32 );
	bool				LexString(uint32 , char*& );

	virtual bool		Parse() = 0;

#pragma export off

};




#endif	/* _BIN_PARSER */

