//
//
//	Text file parser class
//
//											(C) 1997 JoOl


#ifndef _TEXT_PARSER_H
#define _TEXT_PARSER_H

#include "Parser.h"
#include "LexerText.h"



class					ParserText : public Parser
{

#define MATCH(a)		ASSERT(Match(a))

#define PRINT0(s)							_PRINT2("%s%d "s, Indent, Lexr->GetLineNumber())
#define PRINT1(s, a)						_PRINT3("%s%d "s, Indent, Lexr->GetLineNumber(), a)
#define PRINT2(s, a, b)						_PRINT4("%s%d "s, Indent, Lexr->GetLineNumber(), a, b)
#define PRINT3(s, a, b, c)					_PRINT5("%s%d "s, Indent, Lexr->GetLineNumber(), a, b, c)
#define PRINT4(s, a, b, c, d)				_PRINT6("%s%d "s, Indent, Lexr->GetLineNumber(), a, b, c, d)
#define PRINT5(s, a, b, c, d, e)			_PRINT7("%s%d "s, Indent, Lexr->GetLineNumber(), a, b, c, d, e)
#define PRINT6(s, a, b, c, d, e, f)		_PRINT8("%s%d "s, Indent, Lexr->GetLineNumber(), a, b, c, d, e, f)
#define PRINT7(s, a, b, c, d, e, f, g)		_PRINT9("%s%d "s, Indent, Lexr->GetLineNumber(), a, b, c, d, e, f, g)
#define PRINT8(s, a, b, c, d, e, f, g, h)	_PRINTA("%s%d "s, Indent, Lexr->GetLineNumber(), a, b, c, d, e, f, g, h)


protected:

#pragma export on

	Symbol*				SearchSymbol(char* );
	void				PrintSymbol(Symbol* );

	Lexeme*				SearchLexeme(char* );
	char*				DetachLexeme(char* );
	void				DeleteLexeme(char* );

	bool				LexInt(int32& );
	bool				LexFloat(float& );
	bool				ParseFloat(float& );
	bool				ParseString(char*& );
	bool				SkipLine();
	bool				ParseWord(char*& );

	bool				NextToken();
	bool				Match(uint32 );
	bool				Peek(uint32 );

	LexerText*			Lexr;
	uint32				ParserToken;
	bool				PeekFlag;


public:

	ParserText(bool V);
	~ParserText();

	virtual bool		SetInput(entry_ref& );
	virtual void		Terminate();

	bool				EndOfFile();

	virtual bool		Parse() = 0;

#pragma export off

};




#endif	/* _TEXT_PARSER_H */

